﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;

namespace LoadingConfigFromMultipleDependentSourcesCore21
{
    public class Program
    {
        private static IConfiguration Configuration { get; set; }
        public static void Main(string[] args)
        {
            var builder = new ConfigurationBuilder()
                .AddJsonFile("appsettings.json");
            Configuration = builder.Build();
            string otherConfigService = Configuration["otherConfigService"]; // this could be a database or something like consul

            builder.AddJsonFile(otherConfigService);
            Configuration = builder.Build();
            Debug.WriteLine($"Configuration[\"SomeOtherConfigItem1\"] = {Configuration["SomeOtherConfigItem1"]}");
            Debug.WriteLine($"Configuration[\"SomeOtherConfigItem2\"] = {Configuration["SomeOtherConfigItem2"]}");

            CreateWebHostBuilder(args).Build().Run();
        }

        public static IWebHostBuilder CreateWebHostBuilder(string[] args) =>
            WebHost.CreateDefaultBuilder(args)
                .UseStartup<Startup>()
                .UseConfiguration(Configuration); // add this line to add your configuration to the service collection
    }
}
